-
Data Grid
- Overview
-
Data Binding
-
Paging and Scrolling
-
Editing
-
Grouping
-
Filtering and Sorting
- Focused Row
-
Row Drag & Drop
-
Selection
-
Columns
- State Persistence
-
Appearance
-
Templates
-
Data Summaries
-
Master-Detail
-
Export to PDF
-
Export to Excel
-
Adaptability
- Keyboard Navigation
-
Pivot Grid
- Overview
-
Data Binding
-
Field Chooser
-
Features
-
Export to Excel
-
Tree List
- Overview
-
Data Binding
- Sorting
- Paging
-
Editing
- Node Drag & Drop
- Focused Row
-
Selection
-
Filtering
-
Column Customization
- State Persistence
- Adaptability
- Keyboard Navigation
-
Card View
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Features
- Virtual Scrolling
-
Grouping
-
Customization
- Adaptability
-
Html Editor
-
Chat
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
Charts
- Overview
-
Data Binding
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Line Charts
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
-
Sparkline Charts
-
Tree Map
-
Funnel and Pyramid Charts
- Sankey Chart
-
Combinations
-
More Features
-
Export
-
Selection
-
Tooltips
-
Zooming
-
-
Gantt
- Overview
-
Data
-
UI Customization
- Strip Lines
- Export to PDF
- Sorting
-
Filtering
-
Gauges
- Overview
-
Data Binding
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Navigation
- Overview
- Accordion
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
- Stepper
- Pagination
-
Tree View
- Right-to-Left Support
-
Layout
-
Editors
- Overview
- Autocomplete
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Drop Down Box
-
Number Box
-
Select Box
- Switch
-
Tag Box
- Text Area
- Text Box
- Validation
- Custom Text Editor Buttons
- Right-to-Left Support
- Editor Appearance Variants
-
Forms and Multi-Purpose
- Overview
- Button Group
- Field Set
-
Filter Builder
-
Form
- Radio Group
-
Range Selector
- Numeric Scale (Lightweight)
- Numeric Scale
- Date-Time Scale (Lightweight)
- Date-Time Scale
- Logarithmic Scale
- Discrete scale
- Custom Formatting
- Use Range Selection for Calculation
- Use Range Selection for Filtering
- Image on Background
- Chart on Background
- Customized Chart on Background
- Chart on Background with Series Template
- Range Slider
- Slider
-
Sortable
-
File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Actions and Lists
- Overview
-
Action Sheet
-
Button
- Floating Action Button
- Drop Down Button
-
Context Menu
-
List
-
Lookup
-
Maps
- Overview
-
Map
-
Vector Map
-
Dialogs and Notifications
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Diagram - Editing Restrictions
Our JavaScript Diagram component allows you to restrict edit operations as needed. To prohibit a specific operation, set its corresponding property within the editing property to false.
In this demo, the onRequestEditOperation function implements complex logic to determine whether an operation is allowed. The reason event parameter indicates whether the event is raised by a user action or via a UI update. If a user tries to perform a prohibited action, an error message is displayed.
Was this demo helpful?
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
function showToast(text) {
DevExpress.ui.notify({
position: {
at: 'top', my: 'top', of: '#diagram', offset: '0 4',
},
message: text,
type: 'warning',
delayTime: 2000,
});
}
$('#diagram').dxDiagram({
customShapes: [{
category: 'items',
type: 'root',
baseType: 'octagon',
defaultText: 'Development',
},
{
category: 'items',
type: 'team',
title: 'Team',
baseType: 'ellipse',
defaultText: 'Team Name',
},
{
category: 'items',
type: 'employee',
title: 'Employee',
baseType: 'rectangle',
defaultText: 'Employee Name',
}],
nodes: {
dataSource: new DevExpress.data.ArrayStore({
key: 'ID',
data: orgItems,
}),
keyExpr: 'ID',
textExpr: 'Name',
typeExpr: 'Type',
parentKeyExpr: 'ParentID',
styleExpr: itemStyleExpr,
autoLayout: {
type: 'tree',
},
},
onRequestLayoutUpdate(e) {
for (let i = 0; i < e.changes.length; i += 1) {
if (e.changes[i].type === 'remove') { e.allowed = true; } else if (e.changes[i].data.ParentID !== undefined && e.changes[i].data.ParentID !== null) { e.allowed = true; }
}
},
onRequestEditOperation(e) {
const diagram = $('#diagram').dxDiagram().dxDiagram('instance');
if (e.operation === 'addShape') {
if (e.args.shape.type !== 'employee' && e.args.shape.type !== 'team') {
if (e.reason !== 'checkUIElementAvailability') { showToast("You can add only a 'Team' or 'Employee' shape."); }
e.allowed = false;
}
} else if (e.operation === 'deleteShape') {
if (e.args.shape.type === 'root') {
if (e.reason !== 'checkUIElementAvailability') { showToast("You cannot delete the 'Development' shape."); }
e.allowed = false;
}
if (e.args.shape.type === 'team') {
const connectorIds = e.args.shape.attachedConnectorIds;
for (let i = 0; i < connectorIds.length; i += 1) {
if (diagram.getItemById(connectorIds[i]).toId !== e.args.shape.id) {
if (e.reason !== 'checkUIElementAvailability') { showToast("You cannot delete a 'Team' shape that has a child shape."); }
e.allowed = false;
break;
}
}
}
} else if (e.operation === 'resizeShape') {
if (e.args.newSize.width < 1 || e.args.newSize.height < 0.75) {
if (e.reason !== 'checkUIElementAvailability') { showToast('The shape size is too small.'); }
e.allowed = false;
}
} else if (e.operation === 'changeConnection') {
const shapeType = e.args.newShape && e.args.newShape.type;
if (shapeType === 'root' && e.args.connectorPosition === 'end') {
if (e.reason !== 'checkUIElementAvailability') { showToast("The 'Development' shape cannot have an incoming connection."); }
e.allowed = false;
}
if (shapeType === 'employee' && e.args.connectorPosition === 'start') { e.allowed = false; }
} else if (e.operation === 'changeConnectorPoints') {
if (e.args.newPoints.length > 2) {
if (e.reason !== 'checkUIElementAvailability') { showToast('You cannot add points to a connector.'); }
e.allowed = false;
}
} else if (e.operation === 'beforeChangeShapeText') {
if (e.args.shape.type === 'root') {
if (e.reason !== 'checkUIElementAvailability') { showToast("You cannot change the 'Development' shape's text."); }
e.allowed = false;
}
} else if (e.operation === 'changeShapeText') {
if (e.args.text === '') {
if (e.reason !== 'checkUIElementAvailability') { showToast('A shape text cannot be empty.'); }
e.allowed = false;
}
} else if (e.operation === 'beforeChangeConnectorText') {
e.allowed = false;
}
},
contextToolbox: {
shapeIconsPerRow: 2,
width: 100,
shapes: ['team', 'employee'],
},
toolbox: {
shapeIconsPerRow: 2,
groups: [{ title: 'Items', shapes: ['team', 'employee'] }],
},
propertiesPanel: {
visibility: 'disabled',
},
});
function itemStyleExpr(obj) {
if (obj.Type === 'root') { return { fill: '#ffcfc3' }; }
if (obj.Type === 'team') { return { fill: '#b7e3fe' }; }
return { fill: '#bbefcb' };
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="https://cdn3.devexpress.com/jslib/24.2.7/js/dx-diagram.min.js"></script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx-diagram.min.css" />
<link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx.light.css" />
<script src="js/dx.all.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="diagram"> </div>
</div>
</body>
</html>
#diagram {
height: 600px;
}
const orgItems = [
{
ID: '106',
Name: 'Development',
Type: 'root',
},
{
ID: '107',
Name: 'WinForms Team',
Type: 'team',
ParentID: '106',
},
{
ID: '109',
Name: 'Javascript Team',
Type: 'team',
ParentID: '106',
},
{
ID: '110',
Name: 'ASP.NET Team',
Type: 'team',
ParentID: '106',
},
{
ID: '112',
Name: 'Ana Trujillo',
Type: 'employee',
ParentID: '107',
},
{
ID: '113',
Name: 'Antonio Moreno',
Type: 'employee',
ParentID: '107',
},
{
ID: '115',
Name: 'Christina Berglund',
Type: 'employee',
ParentID: '109',
},
{
ID: '116',
Name: 'Hanna Moos',
Type: 'employee',
ParentID: '109',
},
{
ID: '119',
Name: 'Laurence Lebihan',
Type: 'employee',
ParentID: '110',
},
{
ID: '122',
Name: 'Patricio Simpson',
Type: 'employee',
ParentID: '110',
},
{
ID: '123',
Name: 'Francisco Chang',
Type: 'employee',
ParentID: '110',
},
];

Backend API
<template>
<DxDiagram
id="diagram"
@request-edit-operation="onRequestEditOperation"
@request-layout-update="onRequestLayoutUpdate"
>
<DxCustomShape
:category="'items'"
:type="'root'"
:base-type="'octagon'"
:default-text="'Development'"
/>
<DxCustomShape
:category="'items'"
:type="'team'"
:base-type="'ellipse'"
:title="'Team'"
:default-text="'Team Name'"
/>
<DxCustomShape
:category="'items'"
:type="'employee'"
:base-type="'rectangle'"
:title="'Employee'"
:default-text="'Employee Name'"
/>
<DxNodes
:data-source="orgItemsDataSource"
:key-expr="'ID'"
:text-expr="'Name'"
:type-expr="'Type'"
:parent-key-expr="'ParentID'"
:style-expr="itemStyleExpr"
>
<DxAutoLayout
:type="'tree'"
/>
</DxNodes>
<DxContextToolbox
:shape-icons-per-row="2"
:width="100"
:shapes="shapes"
/>
<DxToolbox
:shape-icons-per-row="2"
>
<DxGroup
:title="'Items'"
:shapes="shapes"
/>
</DxToolbox>
<DxPropertiesPanel
:visibility="'disabled'"
/>
</DxDiagram>
</template>
<script setup lang="ts">
import {
DxDiagram,
DxCustomShape,
DxNodes,
DxAutoLayout,
DxContextToolbox,
DxToolbox,
DxPropertiesPanel,
DxGroup,
type DxDiagramTypes,
} from 'devextreme-vue/diagram';
import notify from 'devextreme/ui/notify';
import { ArrayStore } from 'devextreme-vue/common/data';
import service from './data.ts';
const orgItemsDataSource = new ArrayStore({
key: 'ID',
data: service.getOrgItems(),
});
const shapes = ['team', 'employee'] as unknown as DxDiagramTypes.ShapeType[];
const itemStyleExpr = ({ Type }: Record<string, string>) => ({
fill: {
root: '#ffcfc3',
team: '#b7e3fe',
}[Type] || '#bbefcb',
}
);
function showToast(text: string) {
notify({
position: {
at: 'top', my: 'top', of: '#diagram', offset: '0 4',
},
message: text,
type: 'warning',
delayTime: 2000,
});
}
function onRequestLayoutUpdate(e: DxDiagramTypes.RequestLayoutUpdateEvent) {
for (let i = 0; i < e.changes.length; i += 1) {
if (e.changes[i].type === 'remove') {
e.allowed = true;
} else if (e.changes[i].data.ParentID !== undefined
&& e.changes[i].data.ParentID !== null) {
e.allowed = true;
}
}
}
function onRequestEditOperation(e: Record<string, any>) {
let i;
if (e.operation === 'addShape') {
if (e.args.shape.type !== 'employee' && e.args.shape.type !== 'team') {
if (e.reason !== 'checkUIElementAvailability') {
showToast('You can add only a \'Team\' or \'Employee\' shape.');
}
e.allowed = false;
}
} else if (e.operation === 'deleteShape') {
if (e.args.shape.type === 'root') {
if (e.reason !== 'checkUIElementAvailability') {
showToast('You cannot delete the \'Development\' shape.');
}
e.allowed = false;
}
if (e.args.shape.type === 'team') {
const connectorIds = e.args.shape.attachedConnectorIds;
for (i = 0; i < connectorIds.length; i += 1) {
if (e.component.instance().getItemById(connectorIds[i]).toId !== e.args.shape.id) {
if (e.reason !== 'checkUIElementAvailability') {
showToast('You cannot delete a \'Team\' shape that has a child shape.');
}
e.allowed = false;
break;
}
}
}
} else if (e.operation === 'resizeShape') {
if (e.args.newSize.width < 1 || e.args.newSize.height < 0.75) {
if (e.reason !== 'checkUIElementAvailability') {
showToast('The shape size is too small.');
}
e.allowed = false;
}
} else if (e.operation === 'changeConnection') {
const shapeType = e.args.newShape && e.args.newShape.type;
if (shapeType === 'root' && e.args.connectorPosition === 'end') {
if (e.reason !== 'checkUIElementAvailability') {
showToast('The \'Development\' shape cannot have an incoming connection.');
}
e.allowed = false;
}
if (shapeType === 'employee' && e.args.connectorPosition === 'start') {
e.allowed = false;
}
} else if (e.operation === 'changeConnectorPoints') {
if (e.args.newPoints.length > 2) {
if (e.reason !== 'checkUIElementAvailability') {
showToast('You cannot add points to a connector.');
}
e.allowed = false;
}
} else if (e.operation === 'beforeChangeShapeText') {
if (e.args.shape.type === 'root') {
if (e.reason !== 'checkUIElementAvailability') {
showToast('You cannot change the \'Development\' shape\'s text.');
}
e.allowed = false;
}
} else if (e.operation === 'changeShapeText') {
if (e.args.text === '') {
if (e.reason !== 'checkUIElementAvailability') {
showToast('A shape text cannot be empty.');
}
e.allowed = false;
}
} else if (e.operation === 'beforeChangeConnectorText') {
e.allowed = false;
}
}
</script>
<style scoped>
#diagram {
height: 600px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
const orgItems = [{
ID: '106',
Name: 'Development',
Type: 'root',
}, {
ID: '107',
Name: 'WinForms Team',
Type: 'team',
ParentID: '106',
}, {
ID: '109',
Name: 'Javascript Team',
Type: 'team',
ParentID: '106',
}, {
ID: '110',
Name: 'ASP.NET Team',
Type: 'team',
ParentID: '106',
}, {
ID: '112',
Name: 'Ana Trujillo',
Type: 'employee',
ParentID: '107',
}, {
ID: '113',
Name: 'Antonio Moreno',
Type: 'employee',
ParentID: '107',
}, {
ID: '115',
Name: 'Christina Berglund',
Type: 'employee',
ParentID: '109',
}, {
ID: '116',
Name: 'Hanna Moos',
Type: 'employee',
ParentID: '109',
}, {
ID: '119',
Name: 'Laurence Lebihan',
Type: 'employee',
ParentID: '110',
}, {
ID: '122',
Name: 'Patricio Simpson',
Type: 'employee',
ParentID: '110',
}, {
ID: '123',
Name: 'Francisco Chang',
Type: 'employee',
ParentID: '110',
}];
export default {
getOrgItems() {
return orgItems;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Backend API
import React, { useCallback } from 'react';
import Diagram, {
CustomShape, Nodes, AutoLayout, ContextToolbox, Toolbox, PropertiesPanel, Group, type DiagramTypes,
} from 'devextreme-react/diagram';
import notify from 'devextreme/ui/notify';
import { ArrayStore } from 'devextreme-react/common/data';
import service from './data.ts';
const shapes = ['team', 'employee'];
const orgItemsDataSource = new ArrayStore({
key: 'ID',
data: service.getOrgItems(),
});
function showToast(text: string) {
notify({
position: {
at: 'top', my: 'top', of: '#diagram', offset: '0 4',
},
message: text,
type: 'warning',
delayTime: 2000,
});
}
function onRequestLayoutUpdate(e: DiagramTypes.RequestLayoutUpdateEvent) {
for (let i = 0; i < e.changes.length; i += 1) {
if (e.changes[i].type === 'remove') {
e.allowed = true;
} else if (e.changes[i].data.ParentID !== undefined && e.changes[i].data.ParentID !== null) {
e.allowed = true;
}
}
}
function itemStyleExpr(obj: { Type: string; }) {
if (obj.Type === 'root') {
return { fill: '#ffcfc3' };
}
if (obj.Type === 'team') {
return { fill: '#b7e3fe' };
}
return { fill: '#bbefcb' };
}
export default function App() {
const onRequestEditOperation = useCallback((e) => {
const diagram = e.component.instance();
if (e.operation === 'addShape') {
if (e.args.shape.type !== 'employee' && e.args.shape.type !== 'team') {
if (e.reason !== 'checkUIElementAvailability') {
showToast('You can add only a \'Team\' or \'Employee\' shape.');
}
e.allowed = false;
}
} else if (e.operation === 'deleteShape') {
if (e.args.shape.type === 'root') {
if (e.reason !== 'checkUIElementAvailability') {
showToast('You cannot delete the \'Development\' shape.');
}
e.allowed = false;
}
if (e.args.shape.type === 'team') {
for (let i = 0; i < e.args.shape.attachedConnectorIds.length; i += 1) {
if (diagram.getItemById(e.args.shape.attachedConnectorIds[i]).toId !== e.args.shape.id) {
if (e.reason !== 'checkUIElementAvailability') {
showToast('You cannot delete a \'Team\' shape that has a child shape.');
}
e.allowed = false;
break;
}
}
}
} else if (e.operation === 'resizeShape') {
if (e.args.newSize.width < 1 || e.args.newSize.height < 0.75) {
if (e.reason !== 'checkUIElementAvailability') {
showToast('The shape size is too small.');
}
e.allowed = false;
}
} else if (e.operation === 'changeConnection') {
const shapeType = e.args.newShape?.type;
if (shapeType === 'root' && e.args.connectorPosition === 'end') {
if (e.reason !== 'checkUIElementAvailability') {
showToast('The \'Development\' shape cannot have an incoming connection.');
}
e.allowed = false;
}
if (shapeType === 'employee' && e.args.connectorPosition === 'start') {
e.allowed = false;
}
} else if (e.operation === 'changeConnectorPoints') {
if (e.args.newPoints.length > 2) {
if (e.reason !== 'checkUIElementAvailability') {
showToast('You cannot add points to a connector.');
}
e.allowed = false;
}
} else if (e.operation === 'beforeChangeShapeText') {
if (e.args.shape.type === 'root') {
if (e.reason !== 'checkUIElementAvailability') {
showToast('You cannot change the \'Development\' shape\'s text.');
}
e.allowed = false;
}
} else if (e.operation === 'changeShapeText') {
if (e.args.text === '') {
if (e.reason !== 'checkUIElementAvailability') {
showToast('A shape text cannot be empty.');
}
e.allowed = false;
}
} else if (e.operation === 'beforeChangeConnectorText') {
e.allowed = false;
}
}, []);
return (
<Diagram
id="diagram"
onRequestEditOperation={onRequestEditOperation}
onRequestLayoutUpdate={onRequestLayoutUpdate}
>
<CustomShape
category="items"
type="root"
baseType="octagon"
defaultText="Development"
/>
<CustomShape
category="items"
type="team"
baseType="ellipse"
title="Team"
defaultText="Team Name"
/>
<CustomShape
category="items"
type="employee"
baseType="rectangle"
title="Employee"
defaultText="Employee Name"
/>
<Nodes
dataSource={orgItemsDataSource}
keyExpr="ID"
textExpr="Name"
typeExpr="Type"
parentKeyExpr="ParentID"
styleExpr={itemStyleExpr}
>
<AutoLayout type="tree" />
</Nodes>
<ContextToolbox shapeIconsPerRow={2} width={100} shapes={shapes}>
</ContextToolbox>
<Toolbox shapeIconsPerRow={2}>
<Group title="Items" shapes={shapes} />
</Toolbox>
<PropertiesPanel visibility="disabled">
</PropertiesPanel>
</Diagram>
);
}
import React, { useCallback } from 'react';
import Diagram, {
CustomShape,
Nodes,
AutoLayout,
ContextToolbox,
Toolbox,
PropertiesPanel,
Group,
} from 'devextreme-react/diagram';
import notify from 'devextreme/ui/notify';
import { ArrayStore } from 'devextreme-react/common/data';
import service from './data.js';
const shapes = ['team', 'employee'];
const orgItemsDataSource = new ArrayStore({
key: 'ID',
data: service.getOrgItems(),
});
function showToast(text) {
notify({
position: {
at: 'top',
my: 'top',
of: '#diagram',
offset: '0 4',
},
message: text,
type: 'warning',
delayTime: 2000,
});
}
function onRequestLayoutUpdate(e) {
for (let i = 0; i < e.changes.length; i += 1) {
if (e.changes[i].type === 'remove') {
e.allowed = true;
} else if (e.changes[i].data.ParentID !== undefined && e.changes[i].data.ParentID !== null) {
e.allowed = true;
}
}
}
function itemStyleExpr(obj) {
if (obj.Type === 'root') {
return { fill: '#ffcfc3' };
}
if (obj.Type === 'team') {
return { fill: '#b7e3fe' };
}
return { fill: '#bbefcb' };
}
export default function App() {
const onRequestEditOperation = useCallback((e) => {
const diagram = e.component.instance();
if (e.operation === 'addShape') {
if (e.args.shape.type !== 'employee' && e.args.shape.type !== 'team') {
if (e.reason !== 'checkUIElementAvailability') {
showToast("You can add only a 'Team' or 'Employee' shape.");
}
e.allowed = false;
}
} else if (e.operation === 'deleteShape') {
if (e.args.shape.type === 'root') {
if (e.reason !== 'checkUIElementAvailability') {
showToast("You cannot delete the 'Development' shape.");
}
e.allowed = false;
}
if (e.args.shape.type === 'team') {
for (let i = 0; i < e.args.shape.attachedConnectorIds.length; i += 1) {
if (diagram.getItemById(e.args.shape.attachedConnectorIds[i]).toId !== e.args.shape.id) {
if (e.reason !== 'checkUIElementAvailability') {
showToast("You cannot delete a 'Team' shape that has a child shape.");
}
e.allowed = false;
break;
}
}
}
} else if (e.operation === 'resizeShape') {
if (e.args.newSize.width < 1 || e.args.newSize.height < 0.75) {
if (e.reason !== 'checkUIElementAvailability') {
showToast('The shape size is too small.');
}
e.allowed = false;
}
} else if (e.operation === 'changeConnection') {
const shapeType = e.args.newShape?.type;
if (shapeType === 'root' && e.args.connectorPosition === 'end') {
if (e.reason !== 'checkUIElementAvailability') {
showToast("The 'Development' shape cannot have an incoming connection.");
}
e.allowed = false;
}
if (shapeType === 'employee' && e.args.connectorPosition === 'start') {
e.allowed = false;
}
} else if (e.operation === 'changeConnectorPoints') {
if (e.args.newPoints.length > 2) {
if (e.reason !== 'checkUIElementAvailability') {
showToast('You cannot add points to a connector.');
}
e.allowed = false;
}
} else if (e.operation === 'beforeChangeShapeText') {
if (e.args.shape.type === 'root') {
if (e.reason !== 'checkUIElementAvailability') {
showToast("You cannot change the 'Development' shape's text.");
}
e.allowed = false;
}
} else if (e.operation === 'changeShapeText') {
if (e.args.text === '') {
if (e.reason !== 'checkUIElementAvailability') {
showToast('A shape text cannot be empty.');
}
e.allowed = false;
}
} else if (e.operation === 'beforeChangeConnectorText') {
e.allowed = false;
}
}, []);
return (
<Diagram
id="diagram"
onRequestEditOperation={onRequestEditOperation}
onRequestLayoutUpdate={onRequestLayoutUpdate}
>
<CustomShape
category="items"
type="root"
baseType="octagon"
defaultText="Development"
/>
<CustomShape
category="items"
type="team"
baseType="ellipse"
title="Team"
defaultText="Team Name"
/>
<CustomShape
category="items"
type="employee"
baseType="rectangle"
title="Employee"
defaultText="Employee Name"
/>
<Nodes
dataSource={orgItemsDataSource}
keyExpr="ID"
textExpr="Name"
typeExpr="Type"
parentKeyExpr="ParentID"
styleExpr={itemStyleExpr}
>
<AutoLayout type="tree" />
</Nodes>
<ContextToolbox
shapeIconsPerRow={2}
width={100}
shapes={shapes}
></ContextToolbox>
<Toolbox shapeIconsPerRow={2}>
<Group
title="Items"
shapes={shapes}
/>
</Toolbox>
<PropertiesPanel visibility="disabled"></PropertiesPanel>
</Diagram>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
const orgItems = [{
ID: '106',
Name: 'Development',
Type: 'root',
}, {
ID: '107',
Name: 'WinForms Team',
Type: 'team',
ParentID: '106',
}, {
ID: '109',
Name: 'Javascript Team',
Type: 'team',
ParentID: '106',
}, {
ID: '110',
Name: 'ASP.NET Team',
Type: 'team',
ParentID: '106',
}, {
ID: '112',
Name: 'Ana Trujillo',
Type: 'employee',
ParentID: '107',
}, {
ID: '113',
Name: 'Antonio Moreno',
Type: 'employee',
ParentID: '107',
}, {
ID: '115',
Name: 'Christina Berglund',
Type: 'employee',
ParentID: '109',
}, {
ID: '116',
Name: 'Hanna Moos',
Type: 'employee',
ParentID: '109',
}, {
ID: '119',
Name: 'Laurence Lebihan',
Type: 'employee',
ParentID: '110',
}, {
ID: '122',
Name: 'Patricio Simpson',
Type: 'employee',
ParentID: '110',
}, {
ID: '123',
Name: 'Francisco Chang',
Type: 'employee',
ParentID: '110',
}];
export default {
getOrgItems() {
return orgItems;
},
};
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
const orgItems = [
{
ID: '106',
Name: 'Development',
Type: 'root',
},
{
ID: '107',
Name: 'WinForms Team',
Type: 'team',
ParentID: '106',
},
{
ID: '109',
Name: 'Javascript Team',
Type: 'team',
ParentID: '106',
},
{
ID: '110',
Name: 'ASP.NET Team',
Type: 'team',
ParentID: '106',
},
{
ID: '112',
Name: 'Ana Trujillo',
Type: 'employee',
ParentID: '107',
},
{
ID: '113',
Name: 'Antonio Moreno',
Type: 'employee',
ParentID: '107',
},
{
ID: '115',
Name: 'Christina Berglund',
Type: 'employee',
ParentID: '109',
},
{
ID: '116',
Name: 'Hanna Moos',
Type: 'employee',
ParentID: '109',
},
{
ID: '119',
Name: 'Laurence Lebihan',
Type: 'employee',
ParentID: '110',
},
{
ID: '122',
Name: 'Patricio Simpson',
Type: 'employee',
ParentID: '110',
},
{
ID: '123',
Name: 'Francisco Chang',
Type: 'employee',
ParentID: '110',
},
];
export default {
getOrgItems() {
return orgItems;
},
};
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#diagram {
height: 600px;
}

Backend API
<dx-diagram
(onRequestEditOperation)="requestEditOperationHandler($event)"
(onRequestLayoutUpdate)="requestLayoutUpdateHandler($event)"
>
<dxi-diagram-custom-shape
category="items"
[type]="'root'"
baseType="octagon"
[defaultText]="'Development'"
>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="items"
[type]="'team'"
[title]="'Team'"
baseType="ellipse"
[defaultText]="'Team Name'"
>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="items"
[type]="'employee'"
[title]="'Employee'"
baseType="rectangle"
[defaultText]="'Employee Name'"
>
</dxi-diagram-custom-shape>
<dxo-diagram-nodes
[dataSource]="orgItemsDataSource"
keyExpr="ID"
typeExpr="Type"
textExpr="Name"
parentKeyExpr="ParentID"
[styleExpr]="itemStyleExpr"
>
<dxo-diagram-auto-layout type="tree"></dxo-diagram-auto-layout>
</dxo-diagram-nodes>
<dxo-diagram-context-toolbox
[width]="100"
[shapeIconsPerRow]="2"
[shapes]="['team', 'employee']"
>
<dxi-diagram-group category="general" title="General"></dxi-diagram-group>
</dxo-diagram-context-toolbox>
<dxo-diagram-toolbox [shapeIconsPerRow]="2">
<dxi-diagram-group
title="Items"
[shapes]="['team', 'employee']"
></dxi-diagram-group>
</dxo-diagram-toolbox>
<dxo-diagram-properties-panel visibility="disabled">
</dxo-diagram-properties-panel>
</dx-diagram>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { provideHttpClient, withFetch } from '@angular/common/http';
import notify from 'devextreme/ui/notify';
import { ArrayStore } from 'devextreme-angular/common/data';
import { DxDiagramModule, DxDiagramTypes } from 'devextreme-angular/ui/diagram';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
DxDiagramModule,
],
})
export class AppComponent {
orgItemsDataSource: ArrayStore;
constructor(service: Service) {
this.orgItemsDataSource = new ArrayStore({
key: 'ID',
data: service.getOrgItems(),
});
}
showToast(text: string) {
notify({
position: {
at: 'top', my: 'top', of: '#diagram', offset: '0 4',
},
message: text,
type: 'warning',
delayTime: 2000,
});
}
requestLayoutUpdateHandler(e: DxDiagramTypes.RequestLayoutUpdateEvent) {
for (let i = 0; i < e.changes.length; i += 1) {
if (e.changes[i].type === 'remove') { e.allowed = true; } else if (e.changes[i].data.ParentID !== undefined && e.changes[i].data.ParentID !== null) { e.allowed = true; }
}
}
requestEditOperationHandler(e) {
const diagram = e.component.instance();
if (e.operation === 'addShape') {
if (e.args.shape.type !== 'employee' && e.args.shape.type !== 'team') {
if (e.reason !== 'checkUIElementAvailability') { this.showToast("You can add only a 'Team' or 'Employee' shape."); }
e.allowed = false;
}
} else if (e.operation === 'deleteShape') {
if (e.args.shape.type === 'root') {
if (e.reason !== 'checkUIElementAvailability') { this.showToast("You cannot delete the 'Development' shape."); }
e.allowed = false;
}
if (e.args.shape.type === 'team') {
for (let i = 0; i < e.args.shape.attachedConnectorIds.length; i += 1) {
if ((diagram.getItemById(e.args.shape.attachedConnectorIds[i])).toId !== e.args.shape.id) {
if (e.reason !== 'checkUIElementAvailability') { this.showToast("You cannot delete a 'Team' shape that has a child shape."); }
e.allowed = false;
break;
}
}
}
} else if (e.operation === 'resizeShape') {
if (e.args.newSize.width < 1 || e.args.newSize.height < 0.75) {
if (e.reason !== 'checkUIElementAvailability') { this.showToast('The shape size is too small.'); }
e.allowed = false;
}
} else if (e.operation === 'changeConnection') {
const shapeType = e.args.newShape?.type;
if (shapeType === 'root' && e.args.connectorPosition === 'end') {
if (e.reason !== 'checkUIElementAvailability') { this.showToast("The 'Development' shape cannot have an incoming connection."); }
e.allowed = false;
}
if (shapeType === 'employee' && e.args.connectorPosition === 'start') {
e.allowed = false;
}
} else if (e.operation === 'changeConnectorPoints') {
if (e.args.newPoints.length > 2) {
if (e.reason !== 'checkUIElementAvailability') { this.showToast('You cannot add points to a connector.'); }
e.allowed = false;
}
} else if (e.operation === 'beforeChangeShapeText') {
if (e.args.shape.type === 'root') {
if (e.reason !== 'checkUIElementAvailability') { this.showToast("You cannot change the 'Development' shape's text."); }
e.allowed = false;
}
} else if (e.operation === 'changeShapeText') {
if (e.args.text === '') {
if (e.reason !== 'checkUIElementAvailability') { this.showToast('A shape text cannot be empty.'); }
e.allowed = false;
}
} else if (e.operation === 'beforeChangeConnectorText') {
e.allowed = false;
}
}
itemStyleExpr = ({ Type }: Record<string, string>) => (
{
fill: {
root: '#ffcfc3',
team: '#b7e3fe',
}[Type] || '#bbefcb',
}
);
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
provideHttpClient(withFetch()),
],
});
::ng-deep #diagram {
height: 600px;
}
import { Injectable } from '@angular/core';
export class OrgItem {
ID: string;
Name: string;
Type?: string;
ParentID?: string;
}
const orgItems: OrgItem[] = [
{
ID: '106',
Name: 'Development',
Type: 'root',
},
{
ID: '107',
Name: 'WinForms Team',
Type: 'team',
ParentID: '106',
},
{
ID: '109',
Name: 'Javascript Team',
Type: 'team',
ParentID: '106',
},
{
ID: '110',
Name: 'ASP.NET Team',
Type: 'team',
ParentID: '106',
},
{
ID: '112',
Name: 'Ana Trujillo',
Type: 'employee',
ParentID: '107',
},
{
ID: '113',
Name: 'Antonio Moreno',
Type: 'employee',
ParentID: '107',
},
{
ID: '115',
Name: 'Christina Berglund',
Type: 'employee',
ParentID: '109',
},
{
ID: '116',
Name: 'Hanna Moos',
Type: 'employee',
ParentID: '109',
},
{
ID: '119',
Name: 'Laurence Lebihan',
Type: 'employee',
ParentID: '110',
},
{
ID: '122',
Name: 'Patricio Simpson',
Type: 'employee',
ParentID: '110',
},
{
ID: '123',
Name: 'Francisco Chang',
Type: 'employee',
ParentID: '110',
},
];
@Injectable()
export class Service {
getOrgItems() {
return orgItems;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>